program matran_eigenvalues

integer, parameter :: &
   double = selected_real_kind(1+precision(0.0))
integer, parameter :: n = 5
real(kind=double), dimension(n,n) :: A
complex(kind=double), dimension(n) :: e
integer :: i

! Put some values in the matrix A
call random_seed()
call random_number(A)
A = 10.0_double * A - 5.0_double

call eigen_values(A, e)

print *
print *, "The eigenvalues of A are:"
print *
do i = 1, n
   print "(i3, 2(f7.2, a))", i, &
         real(e(i)), " +", &
         imag(e(i)), "i"
end do
print *
print *

contains

subroutine eigen_values (D, e)

   use matrix_module

   real(double), dimension(:, :), intent(in) :: D
   complex(double), dimension(:), intent(out) :: e
   type(Rmat) :: RD
   type(RmatEig) :: eigD

   RD = D
   call Print(RD, 9, 2, "Array D", e = 1)

   call Eig(eigD, RD)

   ! D is the eigenvalue component of eigD
   e = eigD % D

   call Clean(RD)
   call Clean(eigD)

end subroutine eigen_values

end program matran_eigenvalues
