program matran_linear_equations

use matrix_module

integer, parameter :: double = kind(0.0d0)
integer, parameter :: n = 1000
integer :: i
real(kind=double), dimension(n, n) :: R

type(Rmat) :: A, b, x

! Put some values in the matrix A
call random_seed()
call random_number(R)
A = R

! Put some values in the vector b
b = reshape( (/(real(i,double), i = 1, n)/), (/n,1/))
b = A * b

! Solve the linear equations
x = A .xiy. b

! call Print(A, 15, n, "Array A", e=1)
! call Print(b, 15, n, "Vector B", e=1)
! print *
print *
print "(a, /, (tr3, 5es9.2))", &
   "The solution to Ax = B is", x%a(1:n, 1)
print *

call Clean(A)
call Clean(b)
call Clean(x)

end program matran_linear_equations
