module io_module

integer, private, parameter :: max_unit_number = 99
public :: new_unit

integer, parameter, public :: end_of_record = -2             
integer, parameter, public :: end_of_file   = -1

integer, parameter, public :: standard_error_unit  = 0
integer, parameter, public :: standard_input_unit  = 5
integer, parameter, public :: standard_output_unit = 6

contains

!  Returns a unit number that exists and is not connected

subroutine new_unit(unit)

   integer, intent(out) :: unit
   logical :: exists, opened
   integer :: u, ios

   do u = 10, max_unit_number
      inquire (unit = u,  &
               exist = exists,  &
               opened = opened,  &
               iostat = ios)
      if (exists .and. .not. opened .and. ios == 0) then
         unit = u
         return
      end if
   end do

   unit = -1

end subroutine new_unit

end module io_module
